      //-----------------------------------------------------------------------**
      //  Program: DMPIPSTSR
      //
      //  Description : Dump TCP/IP Connection Data
      //
      //-- Header specifications:  --------------------------------------------**
     h dftactgrp(*no)
     h option(*nodebugio:*srcstmt:*seclvl)

     Fipcnsts   O    E             DISK

     FQATOCLS2  if   e           K DISK

      //-- Global declarations:  ----------------------------------------------**
     D LIndex          s             10u 0
     D DIndex          s             10u 0
     D BytesAlcted     s             10u 0
     D UserSpace       s             20a    INZ('DMPTCPCNN QTEMP')
      //
     D Records         s             10u 0
     D TCPConnStat     s              4a
     D ConnOpenTyp     s              3a
     D MSeconds        s             15  0
      //-- Tcp state table:  --------------------------------------------------**
     D TCPStateTable   Ds
     D  TCPStatus                    15a   Dim( 12 )
     D                              180a   Overlay( TCPStateTable)
     D                                     Inz('Listen         SYN-sent       +
     D                                          SYN-receievd   Established    +
     D                                          FIN-wait-1     FIN-wait-2     +
     D                                          Close-wait     Closing        +
     D                                          Last-ACK       Time-wait      +
     D                                          Closed         Not Supported  ')

      //-- Open type table:  --------------------------------------------------**
     D OpenTable       Ds
     D  OpenType                     15a   Dim( 3 )
     D                               45a   Overlay( OpenTable )
     D                                     Inz('Passive        Active         +
     D                                          Not Supported  ')
      //-- API Header information:  -------------------------------------------**
     DHeaderInfo       Ds                  Based( ptrHeaderInfo)
     DHIUsrSpaceNameSp...
     D                               10a
     DHIUsrSpaceibLibrSp...
     D                               10a

      //-- User space generic header:  ---------- -----------------------------**
     DUserSpaceHeader  Ds                  Based( ptrUsrSpc ) qualified
     D OffsetHeader                  10i 0 Overlay(UserSpaceHeader: 117 )
     D OffsetLast                    10i 0 Overlay(UserSpaceHeader: 125 )
     D NumLastEntry                  10i 0 Overlay(UserSpaceHeader: 133 )
     D SizeLastEntry                 10i 0 Overlay(UserSpaceHeader: 137 )
      //-- User space pointers:  ----------------------------------------------**
     D ptrUsrSpc       s               *   Inz( *Null )
     D ptrHdrInf       s               *   Inz( *Null )
     D ptrLstEnt       s               *   Inz( *Null )
      //-- TCP/IP attributes:  ------------------------------------------------**
     D TCPA0100        Ds
     D  T1BytRtn                     10u 0
     D  T1BytAvl                     10u 0
     D  T1StkSts                     10u 0
     D  T1ActTim                     10u 0
     D  T1LstStrD                     8a
     D  T1LstStrT                     6a
     D  T1LstEndD                     8a
     D  T1LstEndT                     6a
     D  T1StrJob                     10a
     D  T1StrUsr                     10a
     D  T1StrNbr                      6a
     D  T1StrJobInt                  16a
     D  T1EndJob                     10a
     D  T1EndUsr                     10a
     D  T1EndNbr                      6a
     D  T1EndJobInt                  16a
     D  T1OfsAddInf                  10u 0
     D  T1LenAddInf                  10u 0
      //-- Connection list qualifier:  ----------------------------------------**
     D NCLQ0100        Ds
     D  N1NetCnnTyp                  10a   Inz( '*ALL' )
     D  N1LstRqsTyp                  10a   Inz( '*ALL' )
     D                               12a   Inz( *Allx'00' )
     D  N1LocAdrLow                  10u 0 Inz( 0 )
     D  N1LocAdrUpr                  10u 0 Inz( 0 )
     D  N1LocPortLow                 10u 0 Inz( 0 )
     D  N1LocPortUpr                 10u 0 Inz( 0 )
     D  N1RmtAdrLow                  10u 0 Inz( 0 )
     D  N1RmtAdrUpr                  10u 0 Inz( 0 )
     D  N1RmtPortLow                 10u 0 Inz( 0 )
     D  N1RmmPortUpr                 10u 0 Inz( 0 )
      //-- Connection list entry:  --------------------------------------------**
     D NCNN0100        Ds                  Based( ptrLstEnt )
     D  C1RmtAdr                     15a
     D                                1a
     D  C1RmtAdrBin                  10u 0
     D  C1LocAdr                     15a
     D                                1a
     D  C1LocAdrBin                  10u 0
     D  C1RmtPort                    10u 0
     D  C1LocPort                    10u 0
     D  C1TcpState                   10u 0
     D  C1IdlTimMs                   10u 0
     D  C1BytIn                      20u 0
     D  C1BytOut                     20u 0
     D  C1ConOpnTyp                  10u 0
     D  C1NetCnnTyp                  10a
     D                                1a
      //-- Following fields were added in V5R2 - do not reference in V5R1:
     D                                1a
     D  C1AscUsrPrf                  10a
     D                                2a
      //-- Socket connection request:  ----------------------------------------**
     D SocCnnRqs       Ds
     D  ScProtocol                   10u 0
     D  ScLocIpAdr                   10u 0
     D  ScLocPortNbr                 10u 0
     D  ScRmtIpAdr                   10u 0
     D  ScRmtPortNbr                 10u 0
      //-- Connection data:  --------------------------------------------------**
     D NCND0100        Ds                  Based( ptrCnnDta )
     D  D1BytRtn                     10u 0
     D  D1BytAvl                     10u 0
     D  D1CurCnnEst                  10u 0
     D  D1ActOpn                     10u 0
     D  D1PasOpn                     10u 0
     D  D1AttOpnFail                 10u 0
     D  D1EstNxtRes                  10u 0
     D  D1SegSnt                     10u 0
     D  D1SegRtr                     10u 0
     D  D1SegRsn                     10u 0
     D  D1SegRcv                     10u 0
     D  D1SegRcvErr                  10u 0
     D  D1DtgSnt                     10u 0
     D  D1DtgRcv                     10u 0
     D  D1DtgNdlPort                 10u 0
     D  D1DtgNdlOde                  10u 0
     D  D1AddInfOfs                  10u 0
     D  D1AddInfLen                  10u 0
      //
     D NCND0200        Ds                  Based( ptrCnnDtaInf )
     D  D2Protocol                   10u 0
     D  D2LocIpAdr                   10u 0
     D  D2LocPortNbr                 10u 0
     D  D2RmtIpAdr                   10u 0
     D  D2RmtPortNbr                 10u 0
     D  D2RndTrpTim                  10u 0
     D  D2RndTrpVar                  10u 0
     D  D2OutBytBuf                  10u 0
     D  D2UsrSndNxt                  10u 0
     D  D2SndNxt                     10u 0
     D  D2SndUnack                   10u 0
     D  D2OutPshNbr                  10u 0
     D  D2OutUrgNbr                  10u 0
     D  D2OutWdwNbr                  10u 0
     D  D2IncBytBuf                  10u 0
     D  D2RcvNxt                     10u 0
     D  D2UsrRcvNxt                  10u 0
     D  D2IncPshNbr                  10u 0
     D  D2IncUrgNbr                  10u 0
     D  D2IncWdwNbr                  10u 0
     D  D2TotRtr                     10u 0
     D  D2CurRtr                     10u 0
     D  D2MaxWdwSiz                  10u 0
     D  D2CurWdwSiz                  10u 0
     D  D2LastUpd                    10u 0
     D  D2LastUpdAck                 10u 0
     D  D2CngWdw                     10u 0
     D  D2SlwStrThr                  10u 0
     D  D2MaxSegSiz                  10u 0
     D  D2InzSndSeqNb                10u 0
     D  D2InzRcvSeqNb                10u 0
     D  D2CnnTspLayer                10u 0
     D  D2TcpState                   10u 0
     D  D2CnnOpnTyp                  10u 0
     D  D2IdlTimMs                   10u 0
     D  D2IpOpt                      40a
     D  D2BytIn                      10u 0
     D  D2BytOut                     10u 0
     D  D2SocState                   10u 0
     D  D2SocLstOfs                  10u 0
     D  D2SocEntNbr                  10u 0
     D  D2SocEntLen                  10u 0
     D  D2JobLstOfs                  10u 0
     D  D2JobEntNbr                  10u 0
     D  D2JobEntLen                  10u 0
      //-- Following fields were added in V5R2 - do not reference in V5R1:
     D  D2AscUsrPrf                  10a
     D                                2a
      //-- Socket options list:
     D SocketOptList   Ds                  Based( ptrSocOptLst ) qualified
     D  Option                       10u 0
     D  Value                        10u 0
      //-- Associated jobs/tasks list:
     D JobConnList     Ds                  Based( ptrJobCnnLst ) qualified
     D  FormatEntry                  10u 0
     D  TaskName                     16a
     D  JobName                      10a
     D  JobUser                      10a
     D  JobNumber                     6a
     D  JobID                        16a

     DJOBI0600         DS                  qualified
     D*                                             JOBI0600
     D BytesReturned           1      4B 0
     D*                                             Bytes Return
     D BytesAvailable          5      8B 0
     D*                                             Bytes Avail
     D JobName                 9     18
     D*                                             Job Name
     D JobUser                19     28
     D*                                             User Name
     D JobNumber              29     34
     D*                                             Job Number
     D InternalJobID          35     50
     D*                                             Int Job ID
     D JobStatus              51     60
     D*                                             Job Status
     D JobType                61     61
     D*                                             Job Type
     D JobSubType             62     62
     D*                                             Job Subtype
     D JobSwitch              63     70
     D*                                             Job Switch
     D EndStatus              71     71
     D*                                             End Status
     D SubsystemName          72     81
     D*                                             Subsys Name
     D SubsystemLibr          82     91
     D*                                             Subsys Lib
     D CurrentUser            92    101
     D*                                             Curr Usrprf Name
     D DBCSEnabled           102    102
     D*                                             Dbcs Enabled
     D ExitKey               103    103
     D*                                             Exit Key
     D CancelKey             104    104
     D*                                             Cancel Key
     D ProdReturnCode        105    108B 0
     D*                                             Product Return Code
     D UserReturnCode        109    112B 0
     D*                                             User Return Code
     D PrgmReturnCode        113    116B 0
     D*                                             Program Return Code
     D SpecialEviron         117    126
     D*                                             Special Environment
     D DeviceName            127    136
     D*                                             Device Name
     D GroupProfile          137    146
     D*                                             Group Profile Name
     D GroupProfileNb                10    DIM(00015)
     D  GroupProfNbr0                10    OVERLAY(GroupProfileNb:00001)
     D JobUserID             297    306
     D*                                             Job User ID
     D JobUSerIDStg          307    307
     D*                                             Job User ID Setting
     D ClientIPAddr          308    322
     D*                                             Client IP Address
     D TimeZoneInfOfs        325    328B 0
     D*                                             Time Zone Info Offset
     D TimeZoneInfLen        329    332B 0
     D*                                             Time Zone Info Length

     d HostEntry       DS                  Based(ptrHostEnt) qualified
    	D  HostName                       *
    	D  Aliases                        *
    	D  AddressType                   5I 0
    	D  Length                        5I 0
    	D  AddressList                    *

     D ptrName         S               *   INZ(*NULL)
     D HostName        S            256A   BASED(ptrName)
     D LocalName       S            256A
     D RemoteName      S            256A
     D LocalSvcName    s             32A
     D LocalSvcDesc    s             50A
     D RemoteSvcName   s             32A
     D RemoteSvcDesc   s             50A

      //-- API Call Prototypes

      // Delete User Space
     dQUSDLTUS         pr                  ExtPgm('QUSDLTUS')
     d   SpcName                     20A
     d   ErrorDS                           likeds(ErrorDS)

      // Get Pointer to User Space Value
     dQUSPTRUS         pr                  ExtPgm('QUSPTRUS')
     d   SpcName                     20A
     d   SpcPtr                        *
     d   ErrorDS                           likeds(ErrorDS)
     d                                     OPTIONS(*NOPASS)

      // Create User Space
     dQUSCRTUS         pr                  ExtPgm('QUSCRTUS')
     d   SPCNAME                     20A   CONST
     d   SPCATTR                     10A   CONST
     d   SPCINITSIZ                   9B 0 CONST
     d   SPCINITVAL                   1A   CONST
     d   SPCAUTH                     10A   CONST
     d   SPCTEXT                     50A   CONST
     d   SPCREPLACE                  10a   CONST OPTIONS(*NOPASS)
     d   ErrorDS                           OPTIONS(*NOPASS)
     d                                     likeds(ErrorDS)
     d   SPCDOMAIN                   10a   CONST OPTIONS(*NOPASS)

      // Get Pointer to User Space Value
     dQUSRJOBI         pr                  ExtPgm('QUSRJOBI')
     D   RcvVar                    6000A   OPTIONS(*VARSIZE)
     D   RCVVARLGTH                  10I 0 CONST
     D   FMTNAME                      8A   CONST
     D   JOBNAME                     26A   CONST
     D   INTJOBID                    16A   CONST
     D  ErrorDS                            likeds(ErrorDS)

      //-- Retrieve TCP/IP attributes:  ---------------------------------------**
     D QtocRtvTCPA     Pr                  ExtProc( 'QtocRtvTCPA' )
     D  RtRcvVar                  32767a          Options( *VarSize )
     D  RtRcvVarLen                  10i 0 Const
     D  RtFmtNam                      8a   Const
     D  RtError                                   likeds(ErrorDS)

      //-- List network connections:  -----------------------------------------**
     D QtocLstNetCnn   Pr                  ExtProc( 'QtocLstNetCnn' )
     D  LcSpcNamQ                    20a   Const
     D  LcFmtNam                      8a   Const
     D  LcCnnQual                    64a   Const
     D  LcCnnQualSiz                 10i 0 Const
     D  LcCnnQualFmt                  8a   Const
     D  LcError                                  likeds(ErrorDS)

      //-- Retrieve network connection data:  ---------------------------------**
     D QtocRtvNetCnnDta...
     D                 Pr                  ExtProc( 'QtocRtvNetCnnDta' )
     D  RcRcvVar                  65535a         Options( *VarSize )
     D  RcRcvVarLen                  10i 0 Const
     D  RcFmtNam                      8a   Const
     D  RcSocCnnRqs                  20a   Const
     D  RcError                                  likeds(ErrorDS)

      //-- Get the host name for a given IP Address --------------------------**
     DGetHostByAddr    PR              *   extproc('gethostbyaddr')
     D  HostEnt                        *   Value
     D  AddrLen                       5I 0 Value
     D  AddrType                      5I 0 Value

      //********* System Data Structure
     dsysDataStr      sds                  qualified
     d ProcedureName           1     10
     d NumParms               37     39  0
     d Exception              40     46
     d JobName               244    253
     d JobUser               254    263
     d JobNumber             264    269  0
     d ProgramName           334    343
     d ModuleName            344    353

      //-- Idle Time Data Structurew ------------------------------------------**
     D IdleDuration    ds                   qualified
     D  Duration               1      9s 0
     D  Hours                  1      5s 0
     D  Minutes                6      7s 0
     D  Seconds                8      9s 0

      //********* System API Error DS
     d ErrorDS         ds                  qualified
     d  BytesProv                    10i 0
     d  BytesAvail                   10i 0
     d  ErrorID                       7a
     d  Error#                        1a
     d  ErrorDsc                    256a

     d HoursRemainder  s              9  0
     d RunTimeStamp    s               z

      // Key list for the IP serivce table file by Port and Protocol
     d klist_qatocls2  ds                        likerec(LRCD1: *key)

      // Constants
     d UPPER_CASE      c                   'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
     d LOWER_CASE      c                   'abcdefghijklmnopqrstuvwxyz'
     d AF_INET         c                   const(2)
     d SOCK_STREAM     c                   const(1)
     d UNUSED          c                   const(0)
     d IPPROTO_IP      c                   const(0)
     d SOL_SOCKET      c                   const(-1)
     d SOL_REUSEADDR   c                   const(55)
     d BufferLen       c                   const(132)



      /FREE

       // Capture the run timestamp;
       RunTimeStamp = %timestamp();

       // Retrieve TCP/IP Attributes
       QTocRtvTCPA( TCPA0100: %Size( TCPA0100 ): 'TCPA0100': ErrorDS);

       //
       if ErrorDS.BytesAvail = 0 and T1StkSts <> 0 and T1StkSts <> 2;
          BytesAlcted = 32767;
          ptrCnnDta     = %Alloc( BytesAlcted );

          //  Create a User Space for the Connection List Entries
          QUSCRTUS( UserSpace: *Blanks: 65535: x'00': '*CHANGE': *Blanks
                   : '*YES': ErrorDS);

          // Get the next list entry for the TCP/IP Connections
          QTocLstNetCnn( UserSpace: 'NCNN0100': NCLQ0100: %Size( NCLQ0100 )
                   : 'NCLQ0100': ErrorDS);
          //
          if ErrorDS.BytesAvail = *Zero;
             exsr processListEntry;
          endif;
          //
          QUSDLTUS(UserSpace: ErrorDS);
          //
          dealloc ptrCnnDta;
          //
       endif;
       //
       *inlr = *on;
       return;

       //-----------------------------------------------------------------------**
       //  Subroutine: processListEntry
       //
       //  Descriptiion: Process Network Connection List Entries
       //
       //-----------------------------------------------------------------------**
       begsr processListEntry;
          //
          QUSPTRUS( UserSpace: ptrUsrSpc);
          //
          ptrHdrInf = ptrUsrSpc + UserSpaceHeader.OffsetHeader;
          ptrLstEnt = ptrUsrSpc + UserSpaceHeader.OffsetLast;
          //
          for LIndex = 1  to UserSpaceHeader.NumLastEntry;
             //
             select;
                when C1NetCnnTyp = '*TCP';
                   ScProtocol  = 1;
                   //
                when C1NetCnnTyp = '*UDP';
                   ScProtocol  = 2;
                   //
                other;
                   ScProtocol  = 0;
             endsl;

             if ScProtocol  > 0;

                // Get the Host Name Information

                // Default Both Values to the IP Addresss in case we
                // don't get a hit for the host name
                RemoteName = %trim(%xlate(x'00':x'40':C1RmtAdr));
                LocalName = %trim(%xlate(x'00':x'40':C1LocAdr));
                ptrHostEnt = getHostByAddr(%addr(C1RmtAdrBin):4:AF_INET);
                if ptrHostEnt <> *NULL;
                   ptrName = HostEntry.HostName;
                   // Trim to the first Null
                   RemoteName = %subst(HostName: 1: %scan(x'00': HostName)-1);

                endif;

                ptrHostEnt = getHostByAddr(%addr(C1LocAdrBin):4:AF_INET);
                if ptrHostEnt <> *NULL;
                   ptrName = HostEntry.HostName;
                   // Trim to the first Null
                   LocalName = %subst(HostName: 1: %scan(x'00': HostName)-1);
                endif;

                // Get the service table name associated with each port
                klist_qatocls2.PORT = c1RmtPort;
                klist_qatocls2.PROTOCOL =
                     %xlate( UPPER_CASE: LOWER_CASE: %subst(C1NetCnnTyp:2:3));
                chain %kds(klist_qatocls2) qatocls2;
                if %found;
                   RemoteSvcName = service;
                   RemoteSvcDesc = text;
                else;
                   RemoteSvcName = %char(c1RmtPort);
                   RemoteSvcDesc = *blanks;
                endif;

                klist_qatocls2.PORT = c1LocPort;
                klist_qatocls2.PROTOCOL =
                     %xlate( UPPER_CASE: LOWER_CASE: %subst(C1NetCnnTyp:2:3));
                chain %kds(klist_qatocls2) qatocls2;
                if %found;
                   LocalSvcName = service;
                   LocalSvcDesc = text;
                else;
                   LocalSvcName = %char(c1LocPort);
                   LocalSvcDesc = *blanks;
                endif;

                //
                sclocipadr  = C1LocAdrBin;
                sclocportNbr= C1LocPort;
                scrmtipadr  = C1RmtAdrBin;
                scrmtportNbr= C1RmtPort;

                //
                dou d1bytAvl <= BytesAlcted;
                   //
                   if d1BytAvl > BytesAlcted;
                      BytesAlcted = D1BytAvl;
                      ptrCnnDta = %ReAlloc( ptrCnnDta: BytesAlcted);
                   endif;
                   //
                   qTOCRtvNetCnnDta( NCND0100: BytesAlcted: 'NCND0200'
                                   : SocCnnRqs: ErrorDS);
                enddo;
                //
                exsr @PrcDtaEnt;
             endif;
             //
             if LIndex < UserSpaceHeader.NumLastEntry;
                ptrLstEnt += UserSpaceHeader.SizeLastEntry;
             endif;
          endfor;
          //
       endsr;

       //-----------------------------------------------------------------------**
       //  Subroutine: @prcDtaEnt
       //
       //  Descriptiion: Process Data Entries
       //
       //-----------------------------------------------------------------------**
       begsr @prcdtaent;
          //
          ptrCnnDtainf  = ptrCnnDta + D1AddInfOfs;
          //
          //-- Socket options:
          if D2SocLstOfs <> 0 and D1AddInfOfs <> 0;
             ptrSocOptlst  = ptrCnnDta + D2SocLstOfs;
             for DIndex = 1 to D2SocEntNbr;
                //
                //--
                if DIndex < D2SocEntNbr;
                   ptrSocOptlst  = ptrSocOptLst + D2SocEntLen;
                endif;
             endfor;
             //
             //-- Associated jobs:
             ptrJobCnnlst  = ptrCnnDta + D2JobLstOfs;
             //
              for DIndex = 1  to D2JobEntNbr;
                //
                if JobConnList.FormatEntry = 1;
                   exsr @wrtJobDtl;
                endif;
                //
                If DIndex < D2JobEntNbr;
                   ptrJobCnnLst  = ptrJobCnnLst + D2JobEntLen;
                endif;
             endfor;
          else;
             exsr @NoJobs;
          endif;
          //
       endsr;

       //-----------------------------------------------------------------------**
       //  Subroutine: @wrtJobDtl
       //
       //  Descriptiion: Write out connection/job detail information
       //
       //-----------------------------------------------------------------------**
       begsr @wrtjobdtl;
          //
          clear ipcnstsr;

          // Connection Information
          // Note the xlATE function is used to remove null characters
          ipcRmtadr  = %trim(%xlate(x'00':x'40':C1RmtAdr));
          ipcRmtport = c1RmtPort;
          ipcRmtSvNm = RemoteSvcName;
          ipcRmtSvDs = RemoteSvcDesc;
          ipcRmtName = RemoteName;
          ipcLocName = LocalName;
          ipcLocAdr =  %trim(%xlate(x'00':x'40':C1LocAdr));
          ipcLocPort = C1LocPort;
          ipcLocSvNm = LocalSvcName;
          ipcLocSvDs = LocalSvcDesc;
          ipcCnnStt  =  TCPStatus(C1TcpState  + 1);
          ipcCnOpnTp  = OpenType(C1ConOpnTyp + 1);
          ipcNetCnTp = C1NetCnnTyp;
          ipcBytIn = C1BytIn;
          ipcBytOut = C1BytOut;

          // Idle Time
          clear IdleDuration ;
          if c1IdlTimMs >0 ;
             IdleDuration .Hours = %div(C1IdlTimMs:3600000);
             HoursRemainder = %rem(C1IdlTimMs:3600000);
             IdleDuration .Minutes = %div(HoursRemainder: 60000);
             IdleDuration .Seconds = (%rem(HoursRemainder: 60000))/1000;
          endif;
          ipcIdlTime = IdleDuration .Duration ;
          MSeconds = c1IdlTimMs*1000;
          ipcLstAct = RunTimeStamp - %mseconds(MSeconds);

          // Job Information
          ipcJobNam = JobConnList.JobName;
          ipcJobUsr = JobConnList.JobUser;
          ipcJobNbr = JobConnList.JobNumber;
          ipcCurrUsr = JobConnList.JobUser;

          // Get the current user for the job
          if ipcJobNbr <> '';
             QUSRJOBI( JOBI0600 :%size(JOBI0600) : 'JOBI0600'
                       : JobConnList.JobName + JobConnList.JobUser
                         + JobConnList.JobNumber
                       : *blanks: ErrorDS);

             if ErrorDS.BytesAvail = *Zero;
                ipcCurrUsr = JOBI0600.CurrentUser;
             endif;
          endif;

          // Run Information
          ipcRunUser = sysDataStr.JobUser;
          ipcRunTms = RunTimeStamp;

          write  ipcnstsr;
       endsr;

       //-----------------------------------------------------------------------**
       //  Subroutine: @noJobs
       //
       //  Descriptiion: Write out connection detail when no jobs exist
       //
       //-----------------------------------------------------------------------**
       begsr @noJobs;
          //
          clear ipcnstsr;

          // Connection Information
          // Note the xlATE function is used to remove null characters
          ipcRmtadr  = %trim(%xlate(x'00':x'40':C1RmtAdr));
          ipcRmtport = c1RmtPort;
          ipcRmtSvNm = RemoteSvcName;
          ipcRmtSvDs = RemoteSvcDesc;
          ipcRmtName = RemoteName;
          ipcLocName = LocalName;
          ipcLocAdr =  %trim(%xlate(x'00':x'40':C1LocAdr));
          ipcLocPort = C1LocPort;
          ipcLocSvNm = LocalSvcName;
          ipcLocSvDs = LocalSvcDesc;
          ipcCnnStt  =  TCPStatus(C1TcpState  + 1);
          ipcCnOpnTp  = OpenType(C1ConOpnTyp + 1);
          ipcNetCnTp = C1NetCnnTyp;
          ipcBytIn = C1BytIn;
          ipcBytOut = C1BytOut;

          // Idle Time
          clear IdleDuration ;
          if c1IdlTimMs >0 ;
             IdleDuration .Hours = %div(C1IdlTimMs:3600000);
             HoursRemainder = %rem(C1IdlTimMs:3600000);
             IdleDuration .Minutes = %div(HoursRemainder: 60000);
             IdleDuration .Seconds = (%rem(HoursRemainder: 60000))/1000;
          endif;
          ipcIdlTime = IdleDuration .Duration ;
          MSeconds = c1IdlTimMs*1000;
          ipcLstAct = RunTimeStamp - %mseconds(MSeconds);

          // Job Information
          ipcJobNam = '';
          ipcJobUsr = '';
          ipcJobNbr = '';
          ipcCurrUsr = '';
          ipcCurrUsr = '';

          // Run Information
          ipcRunUser = sysDataStr.JobUser;
          ipcRunTms = RunTimeStamp;

          write  ipcnstsr;
       endsr;
      /END-FREE

